//=======================================================================
// StdAfx.cpp : stdafx for MS visual studio and headers of common functions
//
// Copyright (c) 2009 Tai-Pang Wu (pang@cse.ust.hk) and HKUST x CUHK
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//=======================================================================

// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once


#include <iostream>
//#include <tchar.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

// TODO: reference additional headers your program requires here

#include <math.h>

#define SIGN(a,b) ((b)<0 ? -fabs(a) : fabs(a))

/////////////////////////////////////////////////////////////////////////////
// Memory Management
#define SAFEDEL(x) { if(x!=NULL) { delete x; x = NULL; } }
#define SAFEDELARR(x) { if(x!=NULL) { delete [] x; x=NULL; } }
/////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
// Other user-defined function
#define nearzero(f) (f >= -EPLSION && f <= EPLSION)
#define RADIAN(deg)	(deg/180.0*PI)
#define DEGREE(rad) (rad/PI*180.0)
////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////
// Other Constants Definition
#define EPLSION					0.000001f
#define PI						3.141592653589793
#define MYINFINITE				1000000000
////////////////////////////////////////////////////////////////////////////

double** allocate2DDouble(int y, int x);
void safeDelete2DDouble( int y, double**& mat );
void copyMatrix( double** from, double** to, int nRows, int nCols );
double matrixDet( double **a, int n );
double pdMatMaxEigV( double** a, int n, int maxIter = INT_MAX );
void   matrixInv3D( double** mat, double** invMat );
void   matrixInv2D( double** mat, double** invMat );

double dotProduct( int dim, double* v1, double* v2 );
double dotProduct3D( double vectorA[3], double vectorB[3] );
double norm3D( double vector[3] );
void minus3D( double vectorA[3], double vectorB[3], double result[3] );
void add3D( double vectorA[3], double vectorB[3], double result[3] );
void eye( int dim, double** mat );
void zeroMat( int y, int x, double** mat );
bool isZeroMat( int y, int x, double** mat );
void addMat( int y, int x, double** mat1, double** mat2, double** output );
void subMat( int y, int x, double** mat1, double** mat2, double** output );
void multiMat( int y, int x, int z, double** mat1, double** mat2, double** output );
void matVecMultiply( int y, int x, double** mat, double* vec, double* outputVec );
void matConstMultiply( int y, int x, double** mat, double constant, double** output );
bool mat2DInverse( double** mat, double** output );
void outerProduct( int dim1, double* vec1, int dim2, double* vec2, double** outMat );
double matFDist2( int y, int x, double** mat1, double** mat2 );
double vecDist2( int dim, double* v1, double* v2 );
double norm2( int dim, double* v );

void int_swap( int& a, int& b);
char* fileExtension(char* path);		// get file extension (Remember to delete the returned parameter and path is modified)

